DogChow = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0")

DogChow.revision = tonumber(string.sub("$Revision: 25921 $", 12, -3))

DogChow.version = "r" .. DogChow.revision

DogChow.date = string.sub("$Date: 2007-01-23 16:50:43 -0500 (Tue, 23 Jan 2007) $", 8, 17)



local Dewdrop = AceLibrary("Dewdrop-2.0")

local Gratuity = AceLibrary("Gratuity-2.0")



local BS = AceLibrary("Babble-Spell-2.2")

local FEED_PET = BS["Feed Pet"]



local L = AceLibrary("AceLocale-2.2"):new("DogChow")

L:RegisterTranslations("enUS", function() return {

} end)



DogChow:RegisterDB("DogChowDB")

DogChow:RegisterDefaults("profile", {

	x = 0,

	y = 0,

	scale = 1,

})



DogChow.options = {

	type = 'group',

	args = {

	},

}



function DogChow:OnInitialize()

end



function DogChow:OnEnable()

	local btn = CreateFrame("CheckButton", "DogChowButton", UIParent, "ActionBarButtonTemplate")

	self.frame = btn

	btn:SetID(101)

	btn:SetScript("OnAttributeChanged", ActionButton_Update)

	self:ScheduleRepeatingEvent(self.CheckHappiness, 5, self)

	local func = btn:GetScript("OnReceiveDrag")

	btn:SetScript("OnReceiveDrag", function(this, ...)

		func(this, ...)

		self:Update()

	end)

	btn:RegisterForClicks("LeftButtonUp")

	btn:RegisterForDrag("LeftButton", "MiddleButton")

	btn:SetMovable(true)

	btn:SetClampedToScreen(true)

	btn:EnableMouseWheel(true)

	btn:SetScript("OnMouseWheel", function(this, up)

		local scale = self.db.profile.scale

		if up > 0 then

			scale = scale / 0.8

			if scale > 4 then

				scale = 4

			end

		else

			scale = scale * 0.8

			if scale < 0.2 then

				scale = 0.2

			end

		end

		btn:SetScale(scale)

		btn:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x/scale, self.db.profile.y/scale)

		self.db.profile.scale = scale

	end)

	local func = btn:GetScript("OnDragStart")

	btn:SetScript("OnDragStart", function(this, ...)

		if arg1 == "LeftButton" then

			return func(this, ...)

		end

		this:StartMoving()

	end)

	btn:SetScript("OnDragStop", function(this)

		local ux, uy = UIParent:GetCenter()

		local x, y = this:GetCenter()

		local scale = self.db.profile.scale

		x, y = x * scale, y * scale

		x, y = x-ux, y-uy

		self.db.profile.x, self.db.profile.y = x, y

		btn:ClearAllPoints()

		btn:SetPoint("CENTER", UIParent, "CENTER", x/scale, y/scale)

		this:StopMovingOrSizing()

	end)

	btn:SetScale(self.db.profile.scale)

	btn:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x/self.db.profile.scale, self.db.profile.y/self.db.profile.scale)

	self:ScheduleEvent(self.CheckHappiness, 0, self)

	self:CheckHappiness()

	self:Update()

	if not DogChowButtonIcon:GetTexture() then

		DogChowButtonIcon:SetTexture("Interface\\Icons\\INV_Misc_Food_19")

	end

end



function DogChow:Update()

	Gratuity:SetAction(self.frame:GetID())

	local food = Gratuity:GetLine(1)

	if food and not self.frame.disabled then

		self:ScheduleLeaveCombatAction(self.frame.SetAttribute, self.frame, "type", "macro")

		self:ScheduleLeaveCombatAction(self.frame.SetAttribute, self.frame, "macrotext", "/cast " .. FEED_PET .. "\n/use " .. food)

	else

		self:ScheduleLeaveCombatAction(self.frame.SetAttribute, self.frame, "type", "none")

	end

end



function DogChow:CheckHappiness()

	local happy = GetPetHappiness() == 3

	local last = self.frame.disabled

	if last == happy then

		return

	end

	self.frame.disabled = happy

	if happy then

		DogChowButtonIcon:SetDesaturated(true)

	else

		DogChowButtonIcon:SetDesaturated(false)

	end

	

	self:Update()

end
